<?php
/* --- vim6 expandtab tabstop=2 shiftwidth=2 ---
	 Atomic Photo Album
	 Copyright (C) 2001-2003 Constantin Charissis <charchi@ifrance.com>

	 This program is free software; you can redistribute it and/or
	 modify it under the terms of the GNU General Public License
	 as published by the Free Software Foundation; either version 2
	 of the License, or (at your option) any later version.

	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.

	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

// PHP >= 4.1.0 Compatibility

define("SHOW_PREV_NEXT_BOTH", 1);
define("SHOW_PREV_NEXT_TOP", 2);
define("SHOW_PREV_NEXT_BOTTOM", 3);

define("SHOW_PREV_NEXT_THUMB", 1);
define("SHOW_PREV_NEXT_TEXT", 2);

if (!empty($_GET)) {
  extract($_GET);
} else if (!empty($HTTP_GET_VARS)) {
  extract($HTTP_GET_VARS);
}

if (!empty($_POST)) {
  extract($_POST);
} else if (!empty($HTTP_POST_VARS)) {
  extract($HTTP_POST_VARS);
}

if (!empty($_COOKIE)) {
  extract($_COOKIE);
} else if (!empty($HTTP_COOKIE_VARS)) {
  extract($HTTP_COOKIE_VARS);
}

if (!empty($_SERVER)) {
  extract($_SERVER);
} else if(!empty($HTTP_SERVER_VARS)) {
  extract($HTTP_SERVER_VARS);
}

switch($action)
{
  case "lang":
  {
    require_once("lang/$lang/install.inc.php");
    break;
  }
  default:
  {
    require_once("lang/english/install.inc.php");
    break;
  }
}

clearstatcache();
if( (!is_writable(getcwd()."/"."apa_config.inc.php")) )
  die("<br><center><b><font color=red>".$l_confmustbewritable."</font></b></center>");


function ask_text_option($text,$name,$size = 30,$maxlength = 255,$value = -1,$br = -1)
{
  print("<tr>\n");
  print("<td>$text</td>\n");
  print("<td>\n");
  print("<input type=\"text\" name=\"$name\"");
  if($value != -1)
    print(" value=\"$value\" ");
  print("size=\"$size\" maxlength=\"$maxlength\" />\n");
  print("</td>\n");
  print("</tr>\n");
}

function ask_password_option($text,$name,$size = 30,$maxlength = 30,$value = -1,$br = -1)
{
  print("<tr>\n");
  print("<td>$text</td>\n");
  print("<td>\n");
  print("<input type=\"password\" name=\"$name\"");
  if($value != -1)
    print(" value=\"$value\" ");
  print("size=\"$size\" maxlength=\"$maxlength\" />\n");
  print("</td>\n");
  print("</tr>\n");
}

function ask_select_option($text,$name,$options,$selected = -1,$br = -1)
{
  print("<tr>\n");
  print("<td>$text</td>\n");
  print("<td>\n");
  print("<select name=\"$name\">\n");
  while( list($key, $value) = each($options) )
  {
    print("<option value=\"$key\"");
    if($selected == $key)
      print(" selected");
    print(">$value</option>\n");
  }
  print("</select>\n");
  print("</td>\n");
  print("</tr>\n");
}

print("<html>\n");
print("<head>\n");
print("<title>$l_installtitle</title>\n");
print("<style type=\"text/css\">\n");
?>
BODY
{
  background-color : #999999;
  font-family : verdana, arial, geneva, sans-serif;
  font-size : 12px;
  font-weight : normal;

  padding : 0px;
  margin : 0px;
}

TABLE,TD
{
  background-color : #9999CC;
  font-family : verdana,arial,geneva,sans-serif;
  font-size : 12px;
  font-weight : normal;

  padding : 0px;
  margin : 0px;
}

FORM
{
  margin : 0em;
  padding : 0.1em;
}

INPUT
{
  background-color : #CCCCFF;
  font-family : verdana, arial, geneva, sans-serif;
  font-size : 11px;
  border-style : none;
}

SELECT {
  background-color : #CCCCFF;
  font-family : verdana, arial, geneva, sans-serif;
  font-size : 11px;
  border-color : black;
}

TEXTAREA {
  background-color : #CCCCFF;
  font-family :  verdana, arial, geneva, sans-serif;
  font-size : 12px;
  font-weight : bold;
  border-style: none;
  text-indent : 2px;
}

<?php
print("</style>\n");
print("</head>\n");
print("<body>\n");

print("<br />\n");
switch($action)
{
  case "install":
  {
    if( strlen($install_dbhost)>2 &&
        strlen($install_dbuser)>=2 &&
        isset($install_dbpassword)>=2 &&
        isset($install_db) &&
        strlen($table_prefix)>=2 &&
        
        strlen($install_adm_login)>=2 &&
        strlen($install_adm_password)>=2 &&
        strlen($install_adm_email)>=2 &&
        
        isset($enable_gd) &&
        strlen($thumb_prefix)>=2 &&
        isset($thumb_width) &&
        isset($thumb_height) &&
        strlen($small_prefix)>=2 &&
        isset($small_width) &&
        isset($small_height) &&
        isset($photo_per_row) &&
        isset($photo_per_col) &&
        isset($album_per_row) &&
        isset($album_per_col) &&
        isset($comments_per_page) &&
        isset($show_prev_next_pos) &&
        isset($show_prev_next_how) &&
        strlen($default_theme)>=2 &&
        
        isset($flood_comments_num) &&
        isset($flood_comments_time) &&
        isset($flood_views_num) &&
        isset($flood_views_time) &&
        isset($mustberegistered) &&
        //isset($as_module) &&
        isset($show_render_time) &&
        isset($disable_user_comments) &&
        isset($disable_rate_support) &&
        isset($allow_anonymous)
        )
    {
      print("<center>\n");
      print("<table align=\"center\">\n");
      print("<tr><td>\n");
      
      print("<strong>$l_trydbconn</strong>\n");
      flush();
      if(!$db=mysql_connect($install_dbhost,$install_dbuser,$install_dbpassword))
      {
        print("<strong><font color=red>$l_dbconnfailure</font></strong><br>\n");
        print("$l_dbhost $install_dbhost<br>\n");
        print("$l_dbuser $install_dbuser<br>\n");
        print("$l_dbpass $install_dbpassword<br>\n");
        print("$l_dbdb $install_db<br>\n");
        die("");
      }
      print("<strong><big>OK!</big></strong><br>\n");
      flush();
      print("<strong>$l_trydbselect<strong>\n");
      flush();
      if(!mysql_select_db($install_db))
      {
        print("<strong>$l_dbselectfail1 $install_db $l_dbselectfail2</strong>\n");
        flush();
        if(!$result=mysql_query("create database $install_db",$db))
        {
          print("<strong><font color=red>$l_dbcreatefail $install_db</font></strong>");
          die("");				
        }
				mysql_select_db($install_db);
      }
      print("<strong><big>OK!</big></strong><br>\n");
      flush();
      print("<strong>$l_tablecreation</strong><br>\n");
      flush();

      $apa_table_prefix = $table_prefix;
      $apa_tables['config'] = $apa_table_prefix."config";
      $apa_tables['users'] = $apa_table_prefix."users";
      $apa_tables['albums'] = $apa_table_prefix."albums";
      $apa_tables['photos'] = $apa_table_prefix."photos";
      $apa_tables['comments'] = $apa_table_prefix."comments";
      $apa_tables['rates'] = $apa_table_prefix."rates";
      $apa_tables['changes'] = $apa_table_prefix."changes";
      $apa_tables['ratesbuffer'] = $apa_table_prefix."ratesbuffer";
      $apa_tables['viewsbuffer'] = $apa_table_prefix."viewsbuffer";
      $apa_tables['commentsbuffer'] = $apa_table_prefix."commentsbuffer";
      $apa_tables['searchindex'] = $apa_table_prefix."searchindex";

      $tables=array(
          $apa_tables['config'] => "CREATE TABLE ".$apa_tables['config']."(
        option_name varchar(50) not null,
        option_value varchar(100) not null,
        ID smallint unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(option_name),
        KEY(option_value)
        )",
          $apa_tables['users'] => "CREATE TABLE ".$apa_tables['users']."(
        nickname varchar(20) not null,
        password varchar(20) not null,
        email varchar(255),
        theme varchar(100) default 'Default',
        lang varchar(100) default 'english',
        nb_comments int unsigned not null default '0',
        nb_rates int unsigned not null default '0',
        level tinyint unsigned not null default '0',
        ID mediumint unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(nickname),
        KEY(password)
        )",
          $apa_tables['albums'] => "CREATE TABLE ".$apa_tables['albums']."(
        name varchar(255) not null default '',
        path varchar(255) not null default '',
        descr text not null default '',
        nb_albums mediumint unsigned not null default '0',
        nb_photos mediumint unsigned not null default '0',
        nb_movies mediumint unsigned not null default '0',
        nb_comments int unsigned not null default '0',
        nb_views int unsigned not null default '0',
        time datetime not null default '0000-00-00 00:00:00',
        parent_ID smallint unsigned not null default '0',
        disabled tinyint unsigned not null default '0',
        ID mediumint unsigned not null auto_increment,
        PRIMARY KEY(ID)
        )",
          $apa_tables['photos'] => "CREATE TABLE ".$apa_tables['photos']."(
        parent_ID mediumint unsigned not null default '0',
        filename text not null default '',
        type tinyint unsigned not null default '1',
        filemtime int unsigned not null default '0',
        filesize int unsigned not null default '0',
        width smallint unsigned not null default '0',
        height smallint unsigned not null default '0',
        descr varchar(255) default '',
        title varchar(120) default '',
        subtitle varchar(120) default '',
        date_taken varchar(40) default '',
        film_type varchar(30) default '',
        rate float unsigned not null default '11.00',
        nb_rates int unsigned not null default '0',
        nb_comments int unsigned not null default '0',
        nb_views int unsigned not null default '0',
        disabled tinyint unsigned not null default '0',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(parent_ID),
        KEY(nb_views)
        )",
        $apa_tables['comments'] => "CREATE TABLE ".$apa_tables['comments']."(
        photo_ID int unsigned not null default '0',
        album_ID mediumint unsigned not null default '0',
        user_ID mediumint unsigned not null default '0',
        content text not null default '',
        time datetime not null default '0000-00-00 00:00:00',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(album_ID),
        KEY(user_ID)
        )",
        $apa_tables['rates'] => "CREATE TABLE ".$apa_tables['rates']."(
        photo_ID int unsigned not null default '0',
        rate smallint unsigned not null default '0',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID)
        )",
        $apa_tables['changes'] => "CREATE TABLE ".$apa_tables['changes']."(
        photo_ID int unsigned not null default '0',
        change_type smallint unsigned not null default '0',
        from_album_ID mediumint unsigned not null default '0',
        to_album_ID mediumint unsigned not null default '0',
        time datetime not null default '0000-00-00 00:00:00',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(change_type),
        KEY(from_album_ID),
        KEY(to_album_ID)
        )",
        $apa_tables['ratesbuffer'] => "CREATE TABLE ".$apa_tables['ratesbuffer']."(
        photo_ID int unsigned not null,
        ip char(15) not null,
        time datetime not null default '00-00-0000 00:00:00',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(ip),
        KEY(time)
        )",
        $apa_tables['viewsbuffer'] => "CREATE TABLE ".$apa_tables['viewsbuffer']."(
        photo_ID int unsigned not null,
        ip char(15) not null,
        time datetime not null default '00-00-0000 00:00:00',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(ip),
        KEY(time)
        )",
        $apa_tables['commentsbuffer'] => "CREATE TABLE ".$apa_tables['commentsbuffer']."(
        photo_ID int unsigned not null,
        ip char(15) not null,
        time datetime not null default '00-00-0000 00:00:00',
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(ip),
        KEY(time)
        )",
        $apa_tables['searchindex'] => "CREATE TABLE ".$apa_tables['searchindex']."(
        photo_ID int unsigned not null,
        content varchar(250) not null,
        ID int unsigned not null auto_increment,
        PRIMARY KEY(ID),
        KEY(photo_ID),
        KEY(content)
        )"
        );

      while (list($name,$query)=each($tables))
      {
        print("<strong>$l_creatingtable $name : </strong>\n");
        flush();
        $result=mysql_query($query);
        if(!$result)
        {
          print("<strong><font color=red>$l_createtablefail</font></strong><br />\n");
          flush();
          print($query.mysql_error()."<br />");
        }
        else
          print("<strong><big>OK!</big></strong><br />\n");
        flush();
      }
      print("<strong>$l_addfirstadmin $install_adm_login : </strong>\n");
      flush();
      $query = "INSERT INTO $apa_tables[users] ";
      $query.= "VALUES('$install_adm_login',";
      $query.= "'$install_adm_password',";
      $query.= "'$install_adm_email',";
      $query.= "'Default',";
      $query.= "'english',";
      $query.= "0,";
      $query.= "0,";
      $query.= "2,";
      $query.= "NULL)";
      $result=mysql_query($query);
      if(!$result)
      {
        print("<strong><font color=red>$l_addfirstadminfail</font></strong><br />\n");
        flush();
        print($query.mysql_error()."<br />");
      }
      else
        print("<strong><big>OK!</big></strong><br />\n");
      flush();

      print("<strong>$l_addanonymous : </strong>\n");
      flush();
      $query = "INSERT INTO $apa_tables[users] ";
      $query.= "VALUES('anonymous',";
      $query.= "'anonymous',";
      $query.= "'noone@nowhere.org',";
      $query.= "'Default',";
      $query.= "'english',";
      $query.= "0,";
      $query.= "0,";
      $query.= "0,";
      $query.= "NULL)";
      $result = mysql_query($query);
      if(!$result)
      {
        print("<strong><font color=red>$l_addanonymousfail</font></strong><br />\n");
        flush();
        print($query.mysql_error()."<br />");
      }
      else
        print("<strong><big>OK!</big></strong><br />\n");

      $as_module = 0;
      print("<strong>$l_writingconfig</strong>\n");
      $fp = fopen("apa_config.inc.php","w");

      if($fp)
      {
        $str = "<?php\n";
        $str.="\$apa_dbhost=\"$install_dbhost\";\n";
        $str.="\$apa_dblogin=\"$install_dbuser\";\n";
        $str.="\$apa_dbpass=\"$install_dbpassword\";\n";
        $str.="\$apa_db=\"$install_db\";\n";
        $str.="\$apa_table_prefix=\"$table_prefix\";\n";
        $str.="\$apa_use_as_module=\"$as_module\";\n";
        $str.="?>";
        
        fputs($fp,$str,strlen($str));
        fclose($fp);
      }
      else
      {
        print("<strong><big>Can't open apa_config.inc.php for writing !</big></strong><br>\n");
        print("Make sure apa_config.inc.php is writeable by the webserver (chmod 777 apa_config.inc.php)</big></strong><br>\n");
      }

      $new_options = array(
        "comments_per_page" => $comments_per_page,
        "flood_comments_num" => $flood_comments_num,
        "flood_comments_time" => $flood_comments_time,
        "flood_views_num" => $flood_views_num,
        "flood_views_time" => $flood_views_time,
        "lang" => $lang,
        "theme" => $default_theme,
        "enable_scan" => 1,
        "enable_gd" => $enable_gd,
        "thumb_prefix" => $thumb_prefix,
        "small_prefix" => $small_prefix,
        "thumb_width" => $thumb_width,
        "thumb_height" => $thumb_height,
        "small_width" => $small_width,
        "small_height" => $small_height,
        "mustberegistered" => $mustberegistered,
        //"as_module" => $as_module,
        "photo_per_row" => $photo_per_row,
        "photo_per_col" => $photo_per_col,
        "album_per_row" => $album_per_row,
        "album_per_col" => $album_per_col,
        "show_prev_next_pos" => $show_prev_next_pos,
        "show_prev_next_how" => $show_prev_next_how,
        "show_render_time" => $show_render_time,
        "disable_user_comments" => $disable_user_comments,
        "disable_rate_support" => $disable_rate_support,
        "allow_anonymous" => $allow_anonymous
      );

      while( list($name,$value) = each($new_options) )
        mysql_query("INSERT INTO ".$apa_tables[config]." VALUES('$name','$value',NULL)");
      
      print("<strong><big>OK!</big></strong><br>\n");
      print("<br /><strong>$l_installfinish</strong><br />\n");
      print("<br />\n");
      print("<center>\n");
      print("<a href=adm.php><strong>$l_adminlink</strong></a>\n");
      print("<a href=index.php><strong>$l_albumlink</strong></a>\n");
      print("</center>\n");
      
      print("</td></tr>\n");
      print("</table>\n");
      print("</center>\n");
    }
    break;
  }
  case "lang":
  {
    print("<center>\n");
    print("<table align=\"center\">\n");

    print("<tr><td align=\"center\" colspan=\"2\">\n");
    print("<strong><big>$l_install</big></strong>\n");
    print("</td></tr>\n");

    print("<form method=post action=install.php>\n");

    print("<tr><td colspan=\"2\">\n");
    print("<strong>$l_dbinfo</strong>\n");
    print("</td></tr>\n");
    ask_text_option($l_dbhost, "install_dbhost", 15);
    ask_text_option($l_dbuser, "install_dbuser", 15);
    ask_password_option($l_dbpass, "install_dbpassword", 15);
    ask_text_option($l_dbdb, "install_db", 15);
    ask_text_option($l_tableprefix, "table_prefix", 15, 30, "apa_");

    print("<tr><td colspan=\"2\">\n");
    print("<strong>$l_admininfo</strong>\n");
    print("</td></tr>\n");
    ask_text_option($l_adminlogin, "install_adm_login", 15, 20);
    ask_password_option($l_adminpass, "install_adm_password", 15, 20);
    ask_text_option($l_adminemail, "install_adm_email", 15);

    print("<tr><td colspan=\"2\">\n");
    print("<strong>$l_displayinfo</strong>\n");
    print("</td></tr>\n");
    $opts = array("1" => $l_yes, "0" => $l_no);
    $selected = 0;
    if( function_exists("ImageCreateFromJPEG") )
    {
      $selected = 1;
      $opts[1] .= " ($l_detected)";
    }
    ask_select_option($l_enablegd, "enable_gd", $opts, $selected);
    ask_text_option($l_thumbprefix, "thumb_prefix", 15, 10, "thumb_");
    ask_text_option($l_thumbwidth, "thumb_width", 15, 10, "200");
    ask_text_option($l_thumbheight, "thumb_height", 15, 10, "100");
    ask_text_option($l_smallprefix, "small_prefix", 15, 10, "small_");
    ask_text_option($l_smallwidth, "small_width", 15, 10, "800");
    ask_text_option($l_smallheight, "small_height", 15, 10, "600");
    ask_text_option($l_photoperrow, "photo_per_row", 15, 10, 3);
    ask_text_option($l_photopercol, "photo_per_col", 15, 10, 5);
    ask_text_option($l_albumperrow, "album_per_row", 15, 10, 3);
    ask_text_option($l_albumpercol, "album_per_col", 15, 10, 5);
    ask_text_option($l_commentsperpage, "comments_per_page", 15, 10, 10);

    $opts = array(SHOW_PREV_NEXT_BOTH => $l_showboth,
      SHOW_PREV_NEXT_TOP => $l_showtop,
      SHOW_PREV_NEXT_BOTTOM => $l_showbottom
    );
    ask_select_option($l_showprevnextpos, "show_prev_next_pos", $opts, SHOW_PREV_NEXT_BOTH);

    $opts = array(SHOW_PREV_NEXT_THUMB => $l_showthumb,
      SHOW_PREV_NEXT_TEXT => $l_showtext
    );
    ask_select_option($l_showprevnexthow, "show_prev_next_how", $opts, SHOW_PREV_NEXT_THUMB);
    
    unset($opts);
    $handle = opendir("themes/");
    while(false !== ($file = readdir($handle)))
    {
      if($file == "." || $file == ".." || $file == "themes")
        continue;
      $opts[$file] = $file;
    }
    closedir($handle);
    ask_select_option($l_defaulttheme, "default_theme", $opts, "Default");

    print("<tr><td colspan=\"2\">\n");
    print("<strong>$l_userinfo</strong>\n");
    print("</td></tr>\n");
    ask_text_option($l_floodcomments1, "flood_comments_num", 15, 10, 3, 0);
    $opts = array(5 => "5 $l_minutes",
        10 => "10 $l_minutes",
        15 => "15 $l_minutes",
        20 => "20 $l_minutes",
        30 => "30 $l_minutes",
        60 => "60 $l_minutes");
    ask_select_option($l_floodcomments2, "flood_comments_time", $opts, -1, 0);

    ask_text_option($l_floodviews1, "flood_views_num", 15, 10, 1, 0);
    ask_select_option($l_floodviews2, "flood_views_time", $opts, -1, 0);

    $opts = array(0 => $l_no, 1 => $l_yes);
    ask_select_option($l_mustberegistered, "mustberegistered", $opts);
    //ask_select_option($l_use_as_module, "as_module", $opts);
    ask_select_option($l_showrendertime, "show_render_time", $opts);
    ask_select_option($l_disableusercomments, "disable_user_comments", $opts);
    ask_select_option($l_disableratesupport, "disable_rate_support", $opts);
    ask_select_option($l_allowanonymous, "allow_anonymous", $opts);

    print("<tr><td align=\"center\" colspan=\"2\">\n");
    print("<input type=submit name=install_submit value=$l_installsubmit>\n");
    print("&nbsp;&nbsp;\n");
    print("<input type=reset value=$l_installclear>\n");
    print("</td></tr>\n");
    print("<input type=hidden name=action value=install>\n");
    print("<input type=hidden name=lang value=$lang>\n");
    print("</form>\n");
    print("</table>\n");
    print("</center>\n");
    break;
  }
  default:
  {
    print("<center>\n");
    print("<table align=\"center\">\n");
    print("<tr><td align=\"center\">\n");
    
    print("<strong>Make sure that the apa_config.inc.php file is writeable by the web server (chmod 777 apa_config.inc.php)</strong><br>\n");
		print("<form method=post action=install.php>\n");
    print("<br><strong>$l_selectlang <strong>\n");
    print("<select name=lang>\n");
    $handle = opendir("lang/");
    while(false !== ($file = readdir($handle)))
    {
      if($file == "." || $file == "..")
        continue;
      print("<option value=$file>$file</option>\n");
    }
    closedir($handle);
    print("</select>\n");
    print("<br /><br />\n");
    print("<input type=submit value=$l_selectlangsubmit>\n");
    print("<input type=hidden name=action value=lang>\n");
    print("</form>\n");
    print("</td></tr>\n");
    print("</table>\n");
    print("</center>\n");
    break;
  }
}

print("<center>\n");
require_once("apa_footer.inc.php");
print("</center>\n");

?>
